/*
**************************************************************************

	Filename: DLLMAIN.C


	Rolling Thunder Computing, Inc.
	25 Hearbtreak Rd
	Ipswich MA 01938

  e-mail 73540.3430@compuserve.com
*****************************************************************************
*/


/*
*****************************************************************************
System header files
*****************************************************************************
*/

#include	<windows.h>

/*
*****************************************************************************
Application header files
*****************************************************************************
*/


#include "cclassf.h"
#include "ctimedta.h"


/*
*****************************************************************************
Function prototype files
*****************************************************************************
*/


/*
*****************************************************************************
Global Variables defined here
*****************************************************************************
*/

UINT cfTimeData, cfThreadId ;

// {FE202EF0-8057-11d0-90B8-00608C86B89C}
static const GUID GUID_NonThreadedTimeData = 
{ 0xfe202ef0, 0x8057, 0x11d0, { 0x90, 0xb8, 0x0, 0x60, 0x8c, 0x86, 0xb8, 0x9c } };

// {FE202EF1-8057-11d0-90B8-00608C86B89C}
static const GUID GUID_ApartmentThreadedTimeData = 
{ 0xfe202ef1, 0x8057, 0x11d0, { 0x90, 0xb8, 0x0, 0x60, 0x8c, 0x86, 0xb8, 0x9c } };

// {FE202EF2-8057-11d0-90B8-00608C86B89C}
static const GUID GUID_FreeThreadedTimeData = 
{ 0xfe202ef2, 0x8057, 0x11d0, { 0x90, 0xb8, 0x0, 0x60, 0x8c, 0x86, 0xb8, 0x9c } };

// {FE202EF3-8057-11d0-90B8-00608C86B89C}
static const GUID GUID_BothThreadedTimeData = 
{ 0xfe202ef3, 0x8057, 0x11d0, { 0x90, 0xb8, 0x0, 0x60, 0x8c, 0x86, 0xb8, 0x9c } };


/*
*****************************************************************************
EXTERNS of global variables defined in other files
*****************************************************************************
*/


long g_ObjectCount = 0 ;

__declspec (dllexport) BOOL WINAPI DllMain (HINSTANCE hInst, DWORD why, LPVOID reserved)
{
	if (why == DLL_PROCESS_ATTACH)
	{				
/*
Register private clipboard formats
*/

		cfTimeData = RegisterClipboardFormat ("TimeDataObject") ;
		cfThreadId = RegisterClipboardFormat ("ThreadId") ;
	}

	return TRUE ;
}



STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID *ppv)
{

/*
Create a new class factory and call QueryInterface on it, on
behalf of the COM that called this function.
*/

	CClassFactory *pcf = new CClassFactory ( ) ;

	if (pcf->QueryInterface (riid, ppv) == S_OK)
	{
		pcf->Release ( ) ;
		return S_OK ;
	}
	else
	{
		delete pcf ;
		return E_NOINTERFACE ;
	}
}					 

STDAPI DllCanUnloadNow(void)
{
	if (g_ObjectCount == 0) 
	{
		return S_OK ;
	}
	else
	{
		return S_FALSE ;
	}
}

