/*
**************************************************************************

	Filename:  MAINWIND.C

*****************************************************************************
*/


/*
*****************************************************************************
System header files
*****************************************************************************
*/

#include <windows.h>		    /* required for all Windows applications */


/*
*****************************************************************************
Application header files
*****************************************************************************
*/

#include "main.h"
#include "ctimedta.h"

/*
*****************************************************************************
Function prototype files
*****************************************************************************
*/

/*
*****************************************************************************
Global Variables defined here
*****************************************************************************
*/

long g_ObjectCount = 0 ;
SYSTEMTIME lt ;
CTimeData *lpFirstObj = NULL ;
                               
/*
*****************************************************************************
EXTERNS ofglobal variables defined in other files
*****************************************************************************
*/

extern HWND	hMainWnd ;
extern HINSTANCE hInst ;


/****************************************************************************

    FUNCTION: MainWndProc(HWND, unsigned, WORD, LONG)

    PURPOSE:  Processes messages


****************************************************************************/

long WINAPI MainWndProc (HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{


	switch (message)
	{

		case WM_DESTROY:
		{           
		  	PostQuitMessage (0) ;
		  	return 0 ;
		}
		
		case WM_PAINT:
		{
			PAINTSTRUCT ps ;
			HDC hDC ;
			char out [256] ;
			int length ;
			
			hDC = BeginPaint (hWnd, &ps) ;
			
			TextOut (hDC, 0, 0, "This window is displayed for demonstration purposes only.", 57) ;

			length = wsprintf (out, "g_Object Count == %d", g_ObjectCount) ;
			TextOut (hDC, 0, 20, out, length) ;

			length = wsprintf (out, "%2.2d:%2.2d:%2.2d", lt.wHour, lt.wMinute, lt.wSecond) ;
			TextOut (hDC, 0, 60, out, length) ;

			EndPaint (hWnd, &ps) ;
			return 0 ;
		}

	}
       
	return DefWindowProc(hWnd, message, wParam, lParam) ;
	
}

void ShutDownServer ( ) 
{
	PostMessage (hMainWnd, WM_CLOSE, 0, 0) ;
}