VERSION 5.00
Begin VB.Form frmThreadTest 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Thread Tester!"
   ClientHeight    =   1725
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5805
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   1725
   ScaleWidth      =   5805
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton btnPause 
      Caption         =   "&Pause Thread"
      Height          =   615
      Left            =   1533
      TabIndex        =   3
      Top             =   960
      Width           =   1335
   End
   Begin VB.CommandButton btnStartThread 
      Caption         =   "&Start Thread"
      Height          =   615
      Left            =   131
      TabIndex        =   2
      Top             =   960
      Width           =   1335
   End
   Begin VB.CommandButton btnStopThread 
      Caption         =   "Stop &Thread"
      Height          =   615
      Left            =   2935
      TabIndex        =   4
      Top             =   960
      Width           =   1335
   End
   Begin VB.CommandButton btnEnd 
      Caption         =   "&End"
      Height          =   615
      Left            =   4338
      TabIndex        =   5
      Top             =   960
      Width           =   1335
   End
   Begin VB.Label lblSeconds 
      Caption         =   "0.0"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   24
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   495
      Left            =   4200
      TabIndex        =   1
      Top             =   240
      Width           =   1335
   End
   Begin VB.Label lblTitle 
      Caption         =   "Look Ma!  No timers, just real threads!"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   3855
   End
End
Attribute VB_Name = "frmThreadTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' John Robbins
' Microsoft Systems Journal - August, 1997
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Option Explicit

' This is the static thread handle that will be used by this form
'  to store the executing thread.  If it is 0, then the background
'  thread is not executing.
Private g_hThread As Long

' The array of event handles that are used to coordinate the background
'  thread.  There are two events here.  The first is the stop event
'  that when signaled means that the background thread is supposed
'  to end.  The second event is the event that is signaled when the
'  background thread is supposed to be updating the label control
'  with the count.  If it is non signaled, then the background thread
'  is paused.  The second event is the pause/running event.
Private g_ahSynchEvents(2) As Long

' The flag that indicates the state of the thread so the UI can show the
'  state.
Private g_bThreadIsPaused As Boolean

' The class that holds the label object that will be passed to the
'  thread.  This is done because trying to pass the actual label
'  as the lpParameter to CreateThread always passed zero which obviously
'  will crash.
Private g_clsLabel As LabelClass

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Handles when the form is loaded.
Private Sub Form_Load()

   ' Set the statics to known values, I trust nothing.
   g_hThread = 0
   g_ahSynchEvents(0) = 0
   g_ahSynchEvents(1) = 0
   g_bThreadIsPaused = False

   ' Instanciate the class.
   Set g_clsLabel = New LabelClass
   ' Initialize the label class so that you can really pass the label
   '  to the thread as the parameter.
   Set g_clsLabel.m_lblLabel = lblSeconds

   ' Disable the stop thread and pause buttons.
   btnStopThread.Enabled = False
   btnPause.Enabled = False

End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Called when the form unloads.  If the background thread is running,
'  then it is killed.
Private Sub Form_Unload(Cancel As Integer)

   ' Shut down the thread if needed.
   KillTheThread

   Set g_clsLabel.m_lblLabel = Nothing

End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' The "End" button is pressed.
Private Sub btnEnd_Click()

   Unload frmThreadTest

End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' The user wants to start the thread.
Private Sub btnStartThread_Click()

   ' Make sure that you only get in here if no thread is executing.
#If DEBUGBUILD Then
      If (0 <> g_hThread) Then
         MsgBox ("btnStartThread_Click: g_hThread <> 0")
      End If
#End If

   ' Create the synchronization objects now.
   CreateSynchEvents g_ahSynchEvents

   ' Holds the handle id returned by CreateThread.
   Dim lThreadID As Long

   ' Create the thread.
   g_hThread = CreateThread(0, _
                            0, _
                            AddressOf TheThread.TheThreadSub, _
                            g_clsLabel, _
                            0, lThreadID)

#If DEBUGBUILD Then
      If (0 = g_hThread) Then
         MsgBox ("btnStartThread_Click: g_hThread <> 0")
      End If
#End If

   If (0 <> g_hThread) Then
      ' Disable the start thread button so you don't create extra
      '  threads.
      btnStartThread.Enabled = False

      ' Enable the end thread button so you can kill it.
      btnStopThread.Enabled = True

      ' Enable the pause button.
      btnPause.Enabled = True

   Else
      ' We didn't get started so kill the synch objects.
      Dim bRet As Long

      bRet = CloseHandle(g_ahSynchEvents(0))

#If DEBUGBUILD Then
      If (0 = bRet) Then
         MsgBox ("CloseHandle(g_ahSynchEvents(0)) failed")
      End If
#End If

      bRet = CloseHandle(g_ahSynchEvents(1))

#If DEBUGBUILD Then
      If (0 = bRet) Then
         MsgBox ("CloseHandle(g_ahSynchEvents(1)) failed")
      End If
#End If

   End If

End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' The user wants to pause the thread.
Private Sub btnPause_Click()

#If DEBUGBUILD Then
      If (0 = g_hThread) Then
         MsgBox ("btnStartThread_Click: g_hThread = 0")
      End If
#End If

   Dim bRet As Long

   ' Is the thread already paused?  If it is, then you need to set the
   '  update event, the second in the array, and put the "Pause Thread"
   '  text back on the button.
   If (True = g_bThreadIsPaused) Then
      ' Reset the flag.
      g_bThreadIsPaused = False
      ' Set the text back.
      btnPause.Caption = "&Pause Thread"
      ' Set the event to signaled.
      bRet = SetEvent(g_ahSynchEvents(1))

#If DEBUGBUILD Then
      If (0 = bRet) Then
         MsgBox ("SetEvent(g_ahSynchEvents(1)) failed")
      End If
#End If

   Else

      ' Set the flag.
      g_bThreadIsPaused = True
      ' Set the button caption.
      btnPause.Caption = "&Resume Thread"
      ' Set the paused/running event to non-signaled.
      bRet = ResetEvent(g_ahSynchEvents(1))

#If DEBUGBUILD Then
      If (0 = bRet) Then
         MsgBox ("ResetEvent(g_ahSynchEvents(1)) failed")
      End If
#End If

   End If

End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' The user wants to stop the thread.
Private Sub btnStopThread_Click()

#If DEBUGBUILD Then
      If (0 = g_hThread) Then
         MsgBox ("btnStopThread_Click: g_hThread = 0")
      End If
#End If

   KillTheThread

   ' If the thread is paused, then clear the flag and set the button
   '  back to the proper text.
   If (True = g_bThreadIsPaused) Then
      ' Reset the flag.
      g_bThreadIsPaused = False
      ' Set the text back.
      btnPause.Caption = "&Pause Thread"
   End If

   ' Reset the state of the buttons.
   btnStartThread.Enabled = True
   btnStopThread.Enabled = False
   btnPause.Enabled = False

End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' A private routine to end the background thread.  This is here because
'  it needs to be called from the "Stop" button and during the form
'  unload.
Private Sub KillTheThread()

   If (0 <> g_hThread) Then
      ' Just kill the thread!
      Dim bRet As Long
      ' It is, so signal the quit event then shut down.
      bRet = SetEvent(g_ahSynchEvents(0))

#If DEBUGBUILD Then
      If (0 = bRet) Then
         MsgBox ("SetEvent(g_ahSynchEvents(0)) failed")
      End If
#End If

      ' Wait for the thread to end.
      bRet = WaitForSingleObject(g_hThread, INFINITE)

      ' Close down the synchronization handles.
      bRet = CloseHandle(g_ahSynchEvents(0))

#If DEBUGBUILD Then
      If (0 = bRet) Then
         MsgBox ("CloseHandle(g_ahSynchEvents(0)) failed")
      End If
#End If

      bRet = CloseHandle(g_ahSynchEvents(1))

#If DEBUGBUILD Then
      If (0 = bRet) Then
         MsgBox ("CloseHandle(g_ahSynchEvents(1)) failed")
      End If
#End If

      g_hThread = 0

   End If

End Sub
