// Triangle.cpp : implementation file
//

#include "stdafx.h"
#include "Widget.h"
#include "WidgBase.h"
#include "Triangle.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTriangle

IMPLEMENT_SERIAL(CTriangle, CWidget, 1)

CTriangle::CTriangle()
{
}

CTriangle::CTriangle (LPCRECT pRect)
{
    m_rect = *pRect;
}

CTriangle::CTriangle (int left, int top, int right, int bottom)
{
    m_rect.SetRect (left, top, right, bottom);
}

CTriangle::~CTriangle()
{
}

BEGIN_MESSAGE_MAP(CTriangle, CWidget)
    //{{AFX_MSG_MAP(CTriangle)
        // NOTE - the ClassWizard will add and remove mapping macros here.
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTriangle message handlers

void CTriangle::Draw(CDC * pDC)
{
    CBrush brush (RGB (0, 0, 255)); // Blue
    CBrush* pOldBrush = pDC->SelectObject (&brush);

    CPoint points[3];
    points[0].x = m_rect.left;
    points[0].y = m_rect.bottom;
    points[1].x = m_rect.left + ((m_rect.right - m_rect.left) / 2);
    points[1].y = m_rect.top;
    points[2].x = m_rect.right;
    points[2].y = m_rect.bottom;
    pDC->Polygon (points, 3);

    pDC->SelectObject (pOldBrush);
}

void CTriangle::DrawDragImage(CDC * pDC, POINT point)
{
    int nOldMode = pDC->SetROP2 (R2_NOT);
    CBrush* pOldBrush = (CBrush*) pDC->SelectStockObject (NULL_BRUSH);

    CPoint points[3];
    points[0].x = point.x;
    points[0].y = point.y + m_rect.Height ();
    points[1].x = point.x + (m_rect.Width () / 2);
    points[1].y = point.y;
    points[2].x = point.x + m_rect.Width ();
    points[2].y = point.y + m_rect.Height ();
    pDC->Polygon (points, 3);

    pDC->SelectObject (pOldBrush);
    pDC->SetROP2 (nOldMode);
}

BOOL CTriangle::PtInWidget(POINT point)
{
    if (!m_rect.PtInRect (point))
        return FALSE;

    int cx = min (point.x - m_rect.left, m_rect.right - point.x);
    return ((m_rect.bottom - point.y) <= (2 * cx));
}

int CTriangle::GetType()
{
    return 1; // Triangle
}

void CTriangle::Serialize (CArchive& ar)
{
    CWidget::Serialize (ar);

    if (ar.IsStoring ())
        ar << m_rect;
    else
        ar >> m_rect;
}
