// WidgDoc.cpp : implementation of the CWidgetDoc class
//

#include "stdafx.h"
#include "Widget.h"
#include "WidgBase.h"
#include "Circle.h"
#include "Triangle.h"
#include "Square.h"
#include "WidgDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWidgetDoc

IMPLEMENT_DYNCREATE(CWidgetDoc, CDocument)

BEGIN_MESSAGE_MAP(CWidgetDoc, CDocument)
    //{{AFX_MSG_MAP(CWidgetDoc)
    ON_COMMAND(ID_INSERT_TRIANGLE, OnInsertTriangle)
    ON_COMMAND(ID_INSERT_CIRCLE, OnInsertCircle)
    ON_COMMAND(ID_INSERT_SQUARE, OnInsertSquare)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWidgetDoc construction/destruction

CWidgetDoc::CWidgetDoc()
{
    // TODO: add one-time construction code here

}

CWidgetDoc::~CWidgetDoc()
{
}

BOOL CWidgetDoc::OnNewDocument()
{
    if (!CDocument::OnNewDocument())
        return FALSE;

    m_aWidgets.SetSize (0, 16);
    return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CWidgetDoc serialization

void CWidgetDoc::Serialize(CArchive& ar)
{
    m_aWidgets.Serialize (ar);
}

/////////////////////////////////////////////////////////////////////////////
// CWidgetDoc diagnostics

#ifdef _DEBUG
void CWidgetDoc::AssertValid() const
{
    CDocument::AssertValid();
}

void CWidgetDoc::Dump(CDumpContext& dc) const
{
    CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWidgetDoc commands

void CWidgetDoc::OnInsertCircle() 
{
    AddWidget (0, CRect (10, 10, 100, 100));
    UpdateAllViews (NULL);
}

void CWidgetDoc::OnInsertTriangle() 
{
    AddWidget (1, CRect (10, 10, 100, 100));
    UpdateAllViews (NULL);
}

void CWidgetDoc::OnInsertSquare() 
{
    AddWidget (2, CRect (10, 10, 100, 100));
    UpdateAllViews (NULL);
}

void CWidgetDoc::DeleteContents() 
{
    int nCount = m_aWidgets.GetSize ();
    while (nCount--)
        delete m_aWidgets[nCount];
    m_aWidgets.RemoveAll ();
    
    CDocument::DeleteContents();
}

int CWidgetDoc::GetWidgetCount()
{
    return m_aWidgets.GetSize ();
}

CWidget* CWidgetDoc::GetWidget(int nIndex)
{
    if (nIndex > (m_aWidgets.GetSize () - 1))
        return NULL;
    return (CWidget*) m_aWidgets[nIndex];

}

int CWidgetDoc::AddWidget(int nType, LPCRECT pRect)
{
    int nIndex;
    CWidget* pWidget;

    try {
        switch (nType) {

        case 0: // Circle widget
            pWidget = new CCircle (pRect);
            break;

        case 1: // Triangle widget
            pWidget = new CTriangle (pRect);
            break;

        case 2: // Square widget
            pWidget = new CSquare (pRect);
            break;
        }
        nIndex = m_aWidgets.Add (pWidget);  
    }
    catch (CMemoryException* e) {
        AfxMessageBox ("Out of memory");
        if (pWidget != NULL)
            delete pWidget;
        e->Delete ();
        return -1;
    }
    SetModifiedFlag ();
    return nIndex;
}

BOOL CWidgetDoc::RemoveWidget(int nIndex)
{
    if (nIndex >= m_aWidgets.GetSize ())
        return FALSE;

    delete m_aWidgets[nIndex];
    m_aWidgets.RemoveAt (nIndex);
    return TRUE;
}
